#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <numeric>
#include <vector>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <sstream>
#include <string>
#include <random>
#include <chrono>
#include <fstream>
#include <bitset>
#include <cstdlib>
#include <cstdio>
#include <utility>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

vector<vector<int>> g;
vector<bool> used;
vector<int> colors;
int cnt;
vector<pair<int, int>> ans;
map<int, map<int, bool>> vis;

void dfs(int v, int p = -1) {
    used[v] = true;
    colors[v] = ++cnt;

    for (auto to : g[v]) {
        if (to == p) continue;

        if (!used[to]) {
            dfs(to, v);
            ans.push_back({v, to});
            vis[v][to] = true;
        }
        else {
            if (vis[v][to]) continue;
            colors.push_back(colors[to]);
            ans.push_back({v, colors.size() - 1});
            vis[v][to] = vis[to][v] = true;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m; cin >> n >> m;
    g.resize(n + 1);

    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        g[u].push_back(v), g[v].push_back(u);
    }

    used.resize(1 + n, false), colors.resize(1 + n , -1);
    dfs(1);

    cout << colors.size() - 1 << "\n";
    for (int i = 1; i < colors.size(); ++i) cout << colors[i] << " ";
    cout << "\n";

    for (auto &[u, v] : ans) cout << u << " " << v << "\n";

    return 0;
}