#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

struct que
{
    int x;
    int8_t phase;
    int prev;
};

vector<pair<int, int>> paths;
int out = 0;
queue <que> q;

bool cmp(pair<int, int> a, pair<int, int> b)
{
    return a.first < b.first;
}

int binary_first(int x)
{
    int l = -1, r = paths.size(), mid = 0;
    while (l < r - 1) {
        mid = (l + r) / 2;
        if (paths[mid].first < x) {
            l = mid;
        }
        else {
            r = mid;
        }
    }
    return r;
}

int main()
{
    int  n, m, a, b;
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        cin >> a >> b;
        paths.push_back({ a,b });
        paths.push_back({ b,a });
    }
    sort(paths.begin(), paths.end(), cmp);
    q.push({ 1, 0, 0 });
    int counter = 0;
    while (!q.empty())
    {
        auto p1 = q.front();
        q.pop();
        if (p1.phase != 4)
        {
            int i = binary_first(p1.x);
            while (paths[i].first == p1.x && i < paths.size())
            {
                if(paths[i].second != p1.prev)
                    q.push({ paths[i].second, p1.phase + 1, p1.x });
                i++;
            }
        }
        else if (p1.x == 1)
            counter++;
    }
    cout << counter;
    return 0;
}