import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    static int n, m;
    static ArrayList<Integer>[] gr;
    static TreeSet<Pair> ans;
    static ArrayList<Integer> vs;
    static boolean[] used;

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(System.in);
        PrintWriter pw = new PrintWriter(System.out);
        n = sc.nextInt();
        m = sc.nextInt();

        gr = new ArrayList[n];
        for (int i = 0; i < n; i++)
            gr[i] = new ArrayList<>();

        for (int i = 0; i < m; i++) {
            int from = sc.nextInt() - 1;
            int to = sc.nextInt() - 1;
            gr[from].add(to);
            gr[to].add(from);
        }
        vs = new ArrayList<>();
        for (int i = 0; i < n; i++)
            vs.add(i);
        ans = new TreeSet<>(new PairComp());
        used = new boolean[n];
        dfs(0);
        pw.println(vs.size());
        for (int v : vs) {
            pw.print((v + 1) + " ");
        }
        pw.println();
        for (Pair a : ans) {
            pw.println((a.c + 1) + " " + (a.d + 1));
        }
        pw.close();
    }

    static void dfs(int v) {
        used[v] = true;
        for (int to : gr[v]) {
            if (!used[to]) {
                ans.add(new Pair(v, to, v, to));
                dfs(to);
            } else if(!(ans.contains(new Pair(v, to, -1, -1)) || ans.contains(new Pair(to, v, -1, -1)))) {
                ans.add(new Pair(v, to, v, vs.size()));
                vs.add(to);
            }
        }
    }

}

class Pair {
    int a, b;
    int c, d;

    public Pair(int a, int b, int c, int d) {
        this.a = a;
        this.b = b;
        this.c = c;
        this.d = d;
    }
}
class PairComp implements Comparator<Pair>{
    public int compare(Pair o1, Pair o2){
        return Integer.compare(o1.a, o2.a) * 2 + Integer.compare(o1.b, o2.b);
    }
}

class Scanner {
    static StringTokenizer st = new StringTokenizer("");
    static BufferedReader br;

    public Scanner(InputStream input) {
        br = new BufferedReader(new InputStreamReader(input));
    }

    public Scanner(String file) throws FileNotFoundException {
        br = new BufferedReader(new FileReader(file));
    }

    public String next() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public String nextLine() throws IOException {
        return br.readLine();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public long nexLong() throws IOException {
        return Long.parseLong(next());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

}
