#include <bits/stdc++.h>
#define ll long long
#define fr first
#define se second
using namespace std;
const ll N = 1e5 + 1;

struct pt {
	double x, y;
};

bool cmp (pt a, pt b) {
	return a.x < b.x || a.x == b.x && a.y < b.y;
}

bool cw (pt a, pt b, pt c) {
	return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}

bool ccw (pt a, pt b, pt c) {
	return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}

void convex_hull (vector<pt> & a) {
	if (a.size() == 1)  return;
	sort (a.begin(), a.end(), &cmp);
	pt p1 = a[0],  p2 = a.back();
	vector<pt> up, down;
	up.push_back (p1);
	down.push_back (p1);
	for (size_t i=1; i<a.size(); ++i) {
		if (i==a.size()-1 || cw (p1, a[i], p2)) {
			while (up.size()>=2 && !cw (up[up.size()-2], up[up.size()-1], a[i]))
				up.pop_back();
			up.push_back (a[i]);
		}
		if (i==a.size()-1 || ccw (p1, a[i], p2)) {
			while (down.size()>=2 && !ccw (down[down.size()-2], down[down.size()-1], a[i]))
				down.pop_back();
			down.push_back (a[i]);
		}
	}
	a.clear();
	for (size_t i=0; i<up.size(); ++i)
		a.push_back (up[i]);
	for (size_t i=down.size()-2; i>0; --i)
		a.push_back (down[i]);
}
double dist_between( pair<double,double>x, pair<double,double>y )
{
    double res = sqrt( (x.fr-y.fr)*(x.fr-y.fr) + (x.se-y.se)*(x.se-y.se) );
    return res;
}
int main()
{
    int n, l;
    vector<pt>V;
    vector<pair<double,double>>D;
    cin >> n >> l;
    for( int i = 1; i <= n; i ++ )
    {
        int x, y;
        cin >> x >> y;
        pt p;
        p.x = x + l;
        p.y = y;
        V.push_back(p);

        p.x = x - l;
        p.y = y;
        V.push_back(p);

        p.x = x;
        p.y = y + l;
        V.push_back(p);

        p.x = x;
        p.y = y - l;
        V.push_back(p);
    }
    convex_hull(V);
    for( int i = 0; i < V.size(); i ++ )
        D.push_back( { V[i].x, V[i].y } );
    double dist = 0;
    D.push_back( { V[0].x, V[0].y } );
    for( int i = 1; i < D.size(); i ++ )
        dist += dist_between( D[i], D[i-1] );
    cout << fixed << setprecision(15) << dist << endl;
}
