/*
	Code written by Talant I.D.
*/
 
#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;
 
#define precision(n) fixed << setprecision(n)
#define pb push_back
#define ub upper_bound
#define lb lower_bound
#define mp make_pair
#define eps (double)1e-15
#define PI 2*acos(0.0)
#define endl "\n"
#define sz(v) int((v).size())
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define do_not_disturb ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define OK cout << "OK" << endl;
 
inline bool isvowel(char ch){
	ch = tolower(ch);
	return (ch == 'a' || ch == 'e' || ch == 'i' || ch == 'o' || ch == 'u');
}
 
inline bool isprime(int n){
	if(n < 2 || (n%2 == 0 && n != 2)) return false;
	for(int i = 3; i*i <= n; i++)
		if(n%i == 0) return false;
	return true;
}

class Union{
    private:
        vector <int> saizu, link;
    public:
        Union(int n){
            saizu.assign(n, 1); link.resize(n); 
            iota(all(link), 0);
        }
        int find(int n){
            if(link[n] == n) return n;
            return link[n] = find(link[n]);
        }
        int same(int a, int b){
            return find(a) == find(b);
        }
        void unite(int a, int b){
            if(same(a, b)) return;
            
            a = find(a); b = find(b);
            if(saizu[a] < saizu[b]) swap(a, b);
            
            saizu[a] += saizu[b];
            link[b] = a;
        }
        int getsize(int a){
            return saizu[find(a)];
        }
};

const int mod = 1e9+7;

ll mode(ll a){
    a %= mod;
    if(a < 0) a += mod;
    return a;
}

ll subt(ll a, ll b){
    return mode(mode(a)-mode(b));
}

ll add(ll a, ll b){
    return mode(mode(a)+mode(b));
}

ll mult(ll a, ll b){
    return mode(mode(a)*mode(b));
}

ll binpow(ll a, ll b){
    ll res = 1;
    while(b){
        if(b&1) res = mult(res, a);
        a = mult(a, a);
        b >>= 1;
    }
    return res;
}

const int N = 2e5+7;
vector <vector <int>> graph(N), newgraph(N);
int used[N], color[N], cnt;
set <pii> st;
int n;

void dfs(int v, int p = -1){
    used[v] = 1;
    for(auto to : graph[v]){
        if(used[to] == 1 && to != p){
            cnt++;
            color[v] = v;
            color[n+cnt] = to;
            st.insert(mp(v, n+cnt));
        }
        else if(!used[to]){
            color[v] = v;
            color[to] = to;
            st.insert(mp(min(v, to), max(v, to)));
            dfs(to, v);
        }
    }
    
    used[v] = 2;
}

int main(){
    do_not_disturb
    
    int m, i;
    cin >> n >> m;
    for(i = 0; i < m; i++){
        int x, y;
        cin >> x >> y;
        graph[x].pb(y);
        graph[y].pb(x);
    }
    
    dfs(1);
    
    cout << cnt+n << endl;
    for(int i = 1; i <= cnt+n; i++){
        cout << color[i] << ' ';
    }
    cout << endl;
    for(auto to : st) cout << to.first << ' ' << to.second << endl;
    
	return 0;
}
