#include <bits/stdc++.h>
#define pii pair<int, int>
#define fr first
#define sc second
#define int long long
using namespace std;

const int MAXN = (int)1e5 + 5;
double x[MAXN];
double y[MAXN];

int tox[] = {1, 0, -1, 0};
int toy[] = {0, 1, 0, -1};

struct pt {
	double x, y;
  pt (int x_, int y_) {
    x = x_, y = y_;
  }
};

bool cmp (pt a, pt b) {
	return a.x < b.x || a.x == b.x && a.y < b.y;
}

bool cw (pt a, pt b, pt c) {
	return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}

bool ccw (pt a, pt b, pt c) {
	return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}

void convex_hull (vector<pt> & a) {
	if (a.size() == 1)  return;
	sort (a.begin(), a.end(), &cmp);
	pt p1 = a[0],  p2 = a.back();
	vector<pt> up, down;
	up.push_back (p1);
	down.push_back (p1);
	for (size_t i=1; i<a.size(); ++i) {
		if (i==a.size()-1 || cw (p1, a[i], p2)) {
			while (up.size()>=2 && !cw (up[up.size()-2], up[up.size()-1], a[i]))
				up.pop_back();
			up.push_back (a[i]);
		}
		if (i==a.size()-1 || ccw (p1, a[i], p2)) {
			while (down.size()>=2 && !ccw (down[down.size()-2], down[down.size()-1], a[i]))
				down.pop_back();
			down.push_back (a[i]);
		}
	}
	a.clear();
	for (size_t i=0; i<up.size(); ++i)
		a.push_back (up[i]);
	for (size_t i=down.size()-2; i>0; --i)
		a.push_back (down[i]);
}

double S(double x) {
  return x * x;
}

double dist(pt a, pt b) {
  return sqrt(S(a.x - b.x) + S(a.y - b.y));
}

signed main() {
  ios_base::sync_with_stdio(0); cin.tie(0);
  int n, l;
  cin >> n >> l;
  vector <pt> points;
  set <pii> st;
  for (int i = 1; i <= n; i++) {
    cin >> x[i] >> y[i];
    for (int k = 0; k < 4; k++) {
      int nx = x[i] + tox[k] * l;
      int ny = y[i] + toy[k] * l;
      if (st.find({ny, nx}) == st.end()) {
        points.push_back(pt(nx, ny));
        st.insert({ny, nx});
      }
    }
  }
  convex_hull(points);
  int sz = (int)points.size();
  double ans = 0;
  for (int i = 0; i + 1 < sz; i++) {
    ans += dist(points[i], points[i + 1]);
  }
  ans += dist(points[0], points[sz - 1]);
  cout << fixed << setprecision(6) << ans;
}
