#include<bits/stdc++.h>
using namespace std;
using ll = long long;
const int N = 1e6 + 66;
using ld = long double;

struct pt {
 double x, y;
};
bool cmp (pt a, pt b) {
 return a.x < b.x || a.x == b.x && a.y < b.y;
}
bool cw (pt a, pt b, pt c) {
 return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}
bool ccw (pt a, pt b, pt c) {
 return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}

void convex_hull (vector<pt> & a) {
 if (a.size() == 1) return;
 sort (a.begin(), a.end(), &cmp);
 pt p1 = a[0], p2 = a.back();
 vector<pt> up, down;
 up.push_back (p1);
 down.push_back (p1);
 for (size_t i=1; i<a.size(); ++i) {
 if (i==a.size()-1 || cw (p1, a[i], p2)) {
 while (up.size()>=2 && !cw (up[up.size()-2], up[up.
size()-1], a[i]))
 up.pop_back();
 up.push_back (a[i]);
 }
 if (i==a.size()-1 || ccw (p1, a[i], p2)) {
 while (down.size()>=2 && !ccw (down[down.size()-2],
down[down.size()-1], a[i]))
 down.pop_back();
 down.push_back (a[i]);
 }
 }
 a.clear();
 for (size_t i=0; i<up.size(); ++i)
 a.push_back (up[i]);
 for (size_t i=down.size()-2; i>0; --i)
 a.push_back (down[i]);
}

ld sq(ld a){return a*a;}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n, l;
	cin >> n >> l;
	vector<pt>a;
	for (int i = 1 ; i <= n ; ++ i) {
		int x, y;
		cin >> x >> y;
		a.push_back({x + l, y});
		a.push_back({x - l, y});
		a.push_back({x, y + l});
		a.push_back({x, y - l});
	}
	convex_hull(a);
	ld ans = 0;
	n = a.size();
	for (int i = 0 ; i < n ; ++ i) {
		int j = (i + 1) % n;
		ld dist = sqrt(sq(a[i].x - a[j].x) + sq(a[i].y - a[j].y));
		ans += dist;
	}
	cout << fixed << setprecision(9) << ans;
}
