#include <iostream>
#include <algorithm>
#include <sstream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <queue>
#include <stack>
#include <unordered_set>
#include <climits>
#include <iomanip>
#include <iterator>
#include <cassert>

#ifndef LOCAL_BUILD
#pragma GCC optimize("-fcaller-saves,-fcrossjumping,-fthread-jumps,-funroll-loops,-fwhole-program,-freorder-blocks")
#pragma GCC optimize("-fpartial-inlining,-freorder-functions,-findirect-inlining,-fhoist-adjacent-loads,-ftree-vrp")
#pragma GCC optimize("-fsched-spec,-falign-jumps,-falign-loops,-falign-labels,-fdevirtualize,move-loop-invariants")
#pragma GCC optimize("-fschedule-insns,-fschedule-insns2,-fstrict-aliasing,-fdelete-null-pointer-checks,-fipa-sra")
#pragma GCC optimize("-fstrict-overflow,-falign-functions,-fcse-skip-blocks,-fcse-follow-jumps,-fsched-interblock")
#pragma GCC optimize("rename-registers,unr1oll-loops,inline-functions,inline-small-functions,vpt,function-sections")
#pragma GCC optimize("-frerun-cse-after-loop,-finline-small-functions,-ftree-switch-conversion,-ftree-tail-merge")
#pragma GCC optimize("-foptimize-sibling-calls,-fexpensive-optimizations,-funsafe-loop-optimizations,-ftree-pre")
#pragma GCC optimize("fast-math,Ofast,inline,no-stack-protector,profile-values,data-sections,-ffast-math,-fgcse")
#pragma GCC optimize("inline-functions-called-once,tracer,profile-reorder-functions,unswitch-loops,-fgcse-lm")
#pragma GCC optimize("branch-target-load-optimize,branch-target-load-optimize2,btr-bb-exclusive,-fpeephole2")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,avx,popcnt,abm,mmx,tune=native")
//#pragma GCC target("avx2")
#pragma warning(disable : 4996)
#define _CRT_SECURE_NO_WARNINGS
#endif

using namespace std;

typedef long long ll;
typedef long double ld;
#define double ld

ll INF = 1e9 + 33;
ll GG = 1e15;
const ld PI = acosl(-1);

#define speed                         \
    ios_base::sync_with_stdio(false); \
    cin.tie(0);                       \
    cout.tie(0)

void solve();
signed main() {
    speed;
    solve();
}

struct pt {
    double x, y;
    pt(ld x, ld y) : x(x), y(y) {}
    ld dist(pt other) {
        return hypotl(other.x - x, other.y - y);
    }
};
bool cmp (pt a, pt b) {
    return a.x < b.x || a.x == b.x && a.y < b.y;
}
bool cw (pt a, pt b, pt c) {
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}
bool ccw (pt a, pt b, pt c) {
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}
void convex_hull (vector<pt> & a) {
    if (a.size() == 1) return;
    sort (a.begin(), a.end(), &cmp);
    pt p1 = a[0], p2 = a.back();
    vector<pt> up, down;
    up.push_back (p1);
    down.push_back (p1);
    for (size_t i=1; i<a.size(); ++i) {
        if (i==a.size()-1 || cw (p1, a[i], p2)) {
            while (up.size()>=2 && !cw (up[up.size()-2], up[up.
                size()-1], a[i]))
                up.pop_back();
            up.push_back (a[i]);
        }
        if (i==a.size()-1 || ccw (p1, a[i], p2)) {
            while (down.size()>=2 && !ccw (down[down.size()-2],
                                           down[down.size()-1], a[i]))
                down.pop_back();
            down.push_back (a[i]);
        }
    }
    a.clear();
    for (size_t i=0; i<up.size(); ++i)
        a.push_back (up[i]);
    for (size_t i=down.size()-2; i>0; --i)
        a.push_back (down[i]);
}

void solve() {
    int n, l, x, y;
    cin >> n >> l;
    vector<pt> a;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        a.push_back(pt(x + l, y));
        a.push_back(pt(x - l, y));
        a.push_back(pt(x, y + l));
        a.push_back(pt(x, y - l));
    }
    
    convex_hull(a);
    
    double ans = 0;
    for (int i = 0; i < a.size(); ++i) {
        ans += a[i].dist(a[(i + 1) % a.size()]);
    }
    
    cout << fixed << setprecision(20) << ans << endl;
}