#include<bits/stdc++.h>

using namespace std;
#define int long long
#define fastio ios_base::sync_with_stdio(0); cin.tie(0);
#define fileio freopen("avia.in", "r", stdin); freopen("avia.out", "w", stdout);


int operator^(pair<pair<int, int>, pair<int, int>> l, pair<pair<int, int>, pair<int, int>> r) {
    int lx = l.second.first - l.first.first;
    int ly = l.second.second - l.first.second;
    int rx = r.second.first - r.first.first;
    int ry = r.second.second - r.first.second;
    return lx * ry - ly * rx;
}

int side(pair<pair<int, int>, pair<int, int>> line, pair<int, int> v) {
    pair<pair<int, int>, pair<int, int>> line2 = {line.first, v};
    int cross = (line ^ line2);
    if (cross > 0) {
        return 1;
    } else if (cross < 0) {
        return -1;
    } else {
        return 0;
    }
}

bool cmp_pnt(pair<int, int> a, pair<int, int> b) {
    return a.first < b.first || (a.first == b.first && a.second < b.second);
}

vector<pair<int, int>> convex_hull(vector<pair<int, int>> a) {
    if (a.size() == 1) return a;
    sort(a.begin(), a.end(), cmp_pnt);
    pair<int, int> b = a[0];
    pair<int, int> e = a.back();
    vector<pair<int, int>> l, r;
    l.push_back(b);
    r.push_back(b);
    for (int i = 1; i < a.size(); ++i) {
        if (i == a.size() - 1 || (side({b, e}, a[i]) == 1)) {
            while (l.size() >= 2 && (side({l[l.size() - 2], l[l.size() - 1]}, a[i]) != -1)) { l.pop_back(); }
            l.push_back(a[i]);
        }
        if (i == a.size() - 1 || (side({b, e}, a[i]) == -1)) {
            while (r.size() >= 2 && (side({r[r.size() - 2], r[r.size() - 1]}, a[i]) != 1)) { r.pop_back(); }
            r.push_back(a[i]);
        }
    }
    a.clear();
    for (int i = 0; i < l.size(); ++i) { a.push_back(l[i]); }
    for (int i = ((int) r.size()) - 2; i > 0; --i) { a.push_back(r[i]); }
    return a;
}


signed main() {
    fastio
//    fileio
    int n, l;
    cin >> n >> l;
    vector<pair<int, int>> a (n);
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        a[i] = {x, y};
    }
    vector<pair<int, int>> b;
    for (int i = 1; i <= n; ++i) {
        int i0 = (i - 1) % n;
        int i1 = i % n;
        int i2 = (i + 1) % n;
        if (a[i0].first == a[i1].first) {
            if (a[i1].second > a[i0].second) {
                b.push_back({a[i1].first, a[i1].second + l});
            } else {
                b.push_back({a[i1].first, a[i1].second - l});
            }


            if (a[i1].first > a[i2].first) {
                b.push_back({a[i1].first + l, a[i1].second});
            } else {
                b.push_back({a[i1].first - l, a[i1].second});
            }
        } else {

            if (a[i1].second > a[i2].second) {
                b.push_back({a[i1].first, a[i1].second + l});
            } else {
                b.push_back({a[i1].first, a[i1].second - l});
            }


            if (a[i1].first > a[i0].first) {
                b.push_back({a[i1].first + l, a[i1].second});
            } else {
                b.push_back({a[i1].first - l, a[i1].second});
            }
        }
    }
    vector<pair<int, int>> c = convex_hull(b);
    double P = 0;
    for (int i = 0; i < c.size(); ++i) {
        int i1 = (i + 1) % c.size();
        int f1 = (c[i].first - c[i1].first) * (c[i].first - c[i1].first);
        int f2 = (c[i].second - c[i1].second) * (c[i].second - c[i1].second);
        int sm = f1 + f2;
        P += sqrt(sm);
    }
    cout << fixed << setprecision(8) << P;
}