#include <bits/stdc++.h>
#include <fstream>

using namespace std;

typedef long long ll;
typedef long double ld;


vector<vector<int>> graph;
vector<vector<int>> res;
vector<bool> colored;
vector<int> colors;

int nxt = 0;

void dfs(int v, set<int>& parents) {
    colored[v] = true;

    for(int i = 0; i < graph[v].size(); i++) {
        int u = graph[v][i];

        if(parents.find(u) != parents.end()) continue;

        if(colored[u] == true) {
            colors.push_back(colors[u]);
            res[v].push_back(nxt);
            nxt++;
        }
        else {
            res[v].push_back(u);

            parents.insert(v);
            dfs(u, parents);
            parents.erase(v);
        }
    }

    return;
}


int main() {
    int n, m;
    cin >> n >> m;

    graph.resize(n);
    res.resize(n);
    colors.resize(n);
    colored.resize(n, false);

    for(int i = 0; i < n; i++) {
        colors[i] = i + 1;
    }

    for(int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;

        graph[a].push_back(b);
        graph[b].push_back(a);
    }

    nxt = n;
    set<int> p;
    dfs(0, p);

    cout << colors.size() << endl;

    for(int i = 0; i < colors.size(); i++) {
        cout << colors[i] << " ";
    }
    cout << endl;

    for(int i = 0; i < res.size(); i++) {
        for(int j = 0; j < res[i].size(); j++) {
            cout << i + 1 << " " << res[i][j] + 1 << endl;
        }
    }


    return 0;
}

/*

3 2
1 2
2 3


5 5
1 2
2 3
1 4
3 4
4 5

*/




/*
tests
10 10
0 1 2 3 4 5 6 7 8 9


*/

// E
/*
int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);


    ll n;
    cin >> n;


    ll l = 1, r = n + 1;
    while (r - l > 2) {
        ll m1 = (2 * l + r) / 3;
        ll m2 = (2 * r + l) / 3;

        ll maxLen1 = n / m1 + 1 * (n % m1 != 0),
            maxLen2 = n / m2 + 1 * (n % m2 != 0);

        if (abs(maxLen1 - m1) < abs(maxLen2 - m2)) {
            r = m1;
        }
        else {
            l = m2;
        }
    }

    ll r1 = l,
        r2 = l + 1,
        r3 = l + 2,
        r4 = r;

    ll ans1 = abs((n / r1 + 1 * (n % r1 != 0)) - r1);
    ll ans2 = abs((n / r2 + 1 * (n % r2 != 0)) - r2);
    ll ans3 = abs((n / r3 + 1 * (n % r3 != 0)) - r3);
    ll ans4 = abs((n / r4 + 1 * (n % r4 != 0)) - r4);


    ll ans = min(
       min(ans1, ans2),
       min(ans3, ans4)
    );

    cout << ans << endl;

    return 0;
}*/
