#include <iostream>
#include <vector>
#include <map>
#include <utility>

using namespace std;

vector<int> used;

vector<vector<int>> gr;

vector<pair<int, int>> ans;

vector<int> color;

map<int, int> m_;

void dfs(int now, int back_n) {
    used[now] = 0;
    m_[now] = 1;
    for (auto next : gr[now]) {
        if (used[next]) {
            ans.push_back({now, next});
            dfs(next, now);
        } else if (next != back_n && m_[next] == 0) {
            int col = color[next];
            color.push_back(col);
            ans.push_back({color.size() - 1, now});
        }
    }
    m_[now] = 0;
}

int main()
{
    int n, m;
    cin >> n >> m;
    gr.resize(n + 1);
    used.resize(n + 1, 1);
    color.resize(n + 1);
    for (int i = 1; i <= n; ++i) {
        color[i] = i;
    }
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
    dfs(1, 0);
    cout << color.size() - 1 << "\n";
    for (int i = 1; i < color.size(); ++i) {
        cout << color[i] << " ";
    }
    cout << "\n";
    for (pair <int, int> da : ans) {
        cout << da.first << " " << da.second << "\n";
    }
    return 0;
}
