#include <iostream>
#include <vector>

using namespace std;

long long mod = 1e9 + 7;

long long pow(long long a, int n) {
    if (n == 0) {
        return 1;
    }
    if (n % 2 == 0) {
        long long half = pow(a, n / 2);
        return half * half % mod;
    }
    return pow(a, n - 1) * a % mod;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> gr(n + 1);
    vector<int> neig(n + 1, 0);
    for (int i = 0;i < m; ++i) {
        int x, y;
        cin >> x >> y;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
    for (auto next : gr[1]) {
        neig[next] = 1;
    }
    long long n_f = 1;
    long long n_2_f = 1;
    for (int i = 1;i <= n; ++i) {
        n_f *= i;
        n_f %= mod;
        if (i <= n - 2) {
            n_2_f *= i;
            n_2_f %= mod;
        }
    }
    long long inv_2_f = pow(n_2_f, mod - 2);
    long long sum = 0;
    for (int i = 2; i <= n; ++i) {
        long long cnt = 0;
        for (auto next : gr[i]) {
            if (neig[next]) {
                cnt++;
            }
        }
        cnt = cnt * (cnt - 1) / 2;
        sum += cnt * 2;
    }
    cout << sum;
    return 0;
}
