#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) int((x).size())

typedef unsigned int uint;
typedef int64_t ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const double EPS = 1e-9;
const int MAXN = 1e6 + 10;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 1;

struct Fenwick {
    int n;
    vector<ll> f;

    Fenwick(int _n) {
        n = _n;
        f.assign(n + 1, 0);
    }

    void update(int x, ll v) {
        for (int i = x; i <= n; i += i & -i) {
            f[i] += v;
        }
    }

    ll get_sum(int x) {
        ll s = 0;
        for (int i = x; i > 0; i -= i & -i) {
            s += f[i];
        }
        return s;
    }

    ll get(int L, int R) {
        return get_sum(R) - get_sum(L - 1);
    }
};


void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void solve() {
    int n;
    int sum = 0;
    cin >> n;
    vector<int> a(n);
    for (auto &i: a) {
        cin >> i;
        sum += i;
    }
    bitset<MAXN> dp;
    Fenwick f(MAXN);
    dp[0] = 1;
    for (auto &i: a) {
        dp |= dp << i;
    }
    vector<int> ev;
    for (int i = 1; i < sum; ++i) {
        if (dp[i]) {
            int y = sum - i;
            f.update(y, 1);
            ev.emplace_back(y);
        }
    }
    sort(all(ev));
    ll ans = 0;
    for (int i = 1, j = 0; i < sum; ++i) {
        if (dp[i]) {
            int y = sum - i;
            ans += i * 2;
            ans -= f.get(1, y);
            if (j < sz(ev) && ev[j] == i) {
                f.update(y, -1);
                ++j;
            }
        }
    }
    cout << ans + sum * 2 + 1 << en;
}

int main() {
    fast_in_out();
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
//    freopen("err.txt", "w", stderr);
#endif
    int TESTS = 1;
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
    return 0;
}
