#include <iostream>
#include <iomanip>
#include <fstream>
#include <cstdio>
#include <sstream>
#include <cassert>
#include <vector>
#include <numeric>
#include <string>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <ctime>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) int((x).size())

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> ;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;
const double EPS = 1e-9;
const int MAXN = 5e5;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

bool IS_ONE_TEST = 1;

ld PI = M_PI;

void fast_in_out() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

struct point {
    int x = 0, y = 0;

    point() : x(0), y(0) {}

    point(int x_, int y_) : x(x_), y(y_) {}

    bool operator<(point &a) {
        if (a.x == x) {
            return y < a.y;
        }
        return x < a.x;
    }
};

struct vec {
    int x = 0, y = 0;

    vec() : x(0), y(0) {}

    vec(int x_, int y_) : x(x_), y(y_) {}

    vec(point a, point b) : x(b.x - a.x), y(b.y - a.y) {}

    ld len() const {
        return sqrt(x * x + y * y);
    }

    vec operator*(int k) const {
        return {x * k, y * k};
    }

    void operator*=(int k) {
        x *= k;
        y *= k;
    }

    vec operator+(const vec other) const {
        return {x + other.x, y + other.y};
    }

    vec operator-(const vec other) const {
        return {x - other.x, y - other.y};
    }

    bool operator==(const vec other) const {
        return x == other.x && y == other.y;
    }

    bool operator!=(const vec other) const {
        return !(*this == other);
    }

    ld operator*(const vec other) const {
        return x * other.x + y * other.y;
    }

    int operator^(const vec other) const {
        return x * other.y - y * other.x;
    }
};

point st;

ld angle(const vec a, const vec b) {
//    if (a.x == 0 && a.y == 0) {
//        return 0;
//    }
//    if (b.x == 0 && b.y == 0) {
//        return 0;
//    }
    return atan2(a ^ b, a * b) / PI * 180;
}

ld point_to_seg(const point a, const point b, const point p) {
    ld len;
    vec ab(a, b), ap(a, p), bp(b, p), ba(b, a);
    if ((ab * ap) < 0) {
        len = fabs(ap.len());
    } else if ((ab * bp) > 0) {
        len = fabs(bp.len());
    } else {
        len = fabs((ba ^ ap) / ba.len());
    }
    return len;
}


bool comp(point &a, point &b) {
    vec from(st, {st.x + 1, st.y});
    vec fi(st, a);
    vec se(st, b);
    if (angle(from, fi) < angle(from, se)) {
        return 1;
    } else {
        return 0;
    }
}

void solve() {
    cout << fixed << setprecision(10);
    int n, l;
    cin >> n >> l;
    vector<pii> a(n);
    vector<pii> b;
    b.reserve(4 * n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        b.emplace_back(a[i].first + l, a[i].second);
        b.emplace_back(a[i].first - l, a[i].second);
        b.emplace_back(a[i].first, a[i].second - l);
        b.emplace_back(a[i].first, a[i].second + l);
    }
    sort(all(b));

    b.resize(distance(b.begin(), unique(all(b))));

    st = {b[0].first, b[0].second};
//    cout << st.x << ' ' << st.y << en;
    vector<point> c(sz(b) - 1);

    for (int i = 1; i < sz(b); ++i) {
        c[i -1] = {b[i].first, b[i].second};
    }

    sort(all(c), comp);

//    for (auto [x, y] : c) {
//        cout << x << ' ' << y << '\n';
//    }
//    vec vec1{1, 3};
//    vec vec2{-3, -1};
//
//    cout << (vec1 ^ vec2);
//
//    vec vec3{3, 2};
//    vec vec4{-1, -3};
//
//    cout << (vec3 ^ vec4);

    c.push_back(st);

    stack<point> vip;
    vip.push(st);

    for (int i = 0; i < 1; ++i) {
        vip.push(c[i]);
    }


    for (int i = 1; i < sz(c); i++) {
        point center = vip.top();
        vip.pop();
        point left = vip.top();
        vip.push(center);
        vec first{center, c[i]};
        vec second{center, left};
        int ans = (first ^ second);
        while (vip.size() > 2 && (first ^ second) <= 0) {
            vip.pop();
            center = vip.top();
            vip.pop();
            left = vip.top();
            vip.push(center);
            first = {center, c[i]};
            second = {center, left};
        }
        vip.push(c[i]);
    }

    ld ans = 0;

    vector<point> vector1;

    while (!vip.empty()) {
//        cout << vip.top().x << ' ' << vip.top().y << '\n';
        vector1.emplace_back(vip.top().x, vip.top().y);
        vip.pop();
    }

    for (int i = 0; i < sz(vector1) - 1; ++i) {
        ans += sqrtl((vector1[i].x - vector1[i + 1].x) * (vector1[i].x - vector1[i + 1].x)
                + (vector1[i].y - vector1[i + 1].y) * (vector1[i].y - vector1[i + 1].y));
    }

    cout << ans;
}

int main() {
    fast_in_out();
#ifdef __APPLE__
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
//    freopen("err.txt", "w", stderr);
#endif
    int TESTS = 1;
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
    return 0;
}
