#include <bits/stdc++.h>
using namespace std;
#define int long long
template <class T> ostream &operator << (ostream &out, const vector<T> &a) {
     for (auto& e : a) out << e << ' ';
     return out;
}

struct point{
int x, y;
point(int x=0, int y=0):x(x),y(y){}
};
bool cmp(point s, point a, point b){
    int dx1 =a.x - s.x;
    int dx2 = b.x - s.x;
    int dy1 = a.y - s.y;
    int dy2 = b.y -s.y;
    if (dx1 * dy2 == dy1 * dx2) return (dx1 * dx1 + dy1 * dy1) < (dx2 * dx2 + dy2 * dy2);
    return dy1 * dx2 < dy2 * dx1;
}
signed main(){
    int n, l;
    cin >> n >> l;
    vector<point> points(n);
    for (auto &pt : points) cin >> pt.x >> pt.y;
    auto start = min_element(points.begin(), points.end(), [](point a, point b){return a.x < b.x;});
    point s = *start;
    points.erase(start);
    sort(points.begin(), points.end(), [&](point a, point b){return cmp(s, a, b);});
    vector<point> convex_hull(1, s);
    for (auto &pt : points){
        while (convex_hull.size() >= 2){
                point last = convex_hull.back();
                point prev = *----convex_hull.end();
                int dx1 = -(prev.x - last.x);
                int dy1 = -(prev.y - last.y);
                int dx2 = pt.x - prev.x;
                int dy2 = pt.y - prev.y;
                int cross = dx1 * dy2 - dx2 * dy1;
                if (cross <= 0) convex_hull.pop_back(); else break;
        }
        convex_hull.push_back(pt);
    }
   vector<pair<double, double>> new_hull;
    for (int i = 0; i < convex_hull.size(); ++i){
        point a = convex_hull[i];
        point b = convex_hull[(i + 1) % convex_hull.size()];
        double dx = b.x - a.x;
        double dy = b.y - a.y;
        double len = abs(dx) + abs(dy);
        double k = l / len;
        new_hull.emplace_back(a.x + k * dx, a.y - k * dx);
        new_hull.emplace_back(b.x + k * dx, b.y - k * dx);
    }
    double ans = 0;
    for (int i = 0; i < new_hull.size(); ++i) {
        double x = new_hull[(i + 1) % new_hull.size()].first - new_hull[i].first;
        double y = new_hull[(i + 1) % new_hull.size()].second - new_hull[i].second;
        ans += sqrt(x * x + y * y);
    }
    cout << setprecision(18) << ans << '\n';
}

/*
4 3
-3 -3
-3 3
3 3
3 -3

-3 -3
-3 3
-3 -3*/

/*
4 3
-3 -3
-3 3
3 3
3 -3

*/
