//#define _GLIBCXX_DEBUG
#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::string;
using std::pair;

using ll = long long;
using ld = long double;

const ld EPS = 1e-9;

bool eq (ld a, ld b) {
	return std::abs(a - b) < EPS;
}

bool lt (ld a, ld b) {
	return (a - b < EPS);
}

bool gt (ld a, ld b) {
	return (b - a < EPS);
}

int sign (ld a) {
	if (eq(a, 0))
		return 0;
	if (lt(a, 0))
		return -1;
	return 1;
}

struct Vector {
	ll x, y;

	Vector (ll x, ll y) : x(x), y(y) {};
	Vector(){};

	ld len() {
		return std::sqrt((ld)x * x + y * y);
	}
};

std::ostream& operator << (std::ostream& out, const Vector& v) {
	out << v.x << ' ' << v.y;
	return out;
}

std::istream& operator >> (std::istream& in, Vector& v) {
	in >> v.x >> v.y;
	return in;
}

bool operator == (Vector a, Vector b) {
	return a.x == b.x && a.y == b.y;
}

Vector operator + (Vector a, Vector b) {
	return Vector(a.x + b.x, a.y + b.y);
}

Vector operator - (Vector a, Vector b) {
	return Vector(a.x - b.x, a.y - b.y);
}

Vector start(0, 0);

ll vectorMpl(Vector a, Vector b) {
	return a.x * b.y - a.y * b.x;
}

bool check(Vector a, Vector b, Vector c) {
	Vector v1 = b - a;
	Vector v2 = c - a;
	return vectorMpl(v1, v2) > 0;

}

bool cmp (Vector a, Vector b) {
	return check(start, a, b);
}


bool cmp1 (Vector a, Vector b) {
	return (a.x < b.x || (a.x == b.x && a.y < b.y));
}


int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n;
	ll l;
	cin >> n >> l;
	vector<Vector> v(4 * n);
	for (int i = 0; i < n; ++i) {
		Vector a;
		cin >> a;
		v[4 * i] = a + Vector(0, l);
		v[4 * i + 1] = a + Vector(0, -l);
		v[4 * i + 2] = a + Vector(l, 0);
		v[4 * i + 3] = a + Vector(-l, 0);
	}

	std::sort(v.begin(), v.end(), cmp1);
	v.resize(std::unique(v.begin(), v.end()) - v.begin());

	for (int i = 0; i < n; ++i) {
		if (v[i].x < v[0].x || (v[i].x == v[0].x && v[i].y < v[0].y))
			std::swap(v[0], v[i]);
	}

	start = v[0];

	std::sort(v.begin() + 1, v.end(), cmp);

	vector<Vector> hull;
	for (int i = 0; i < v.size(); ++i) {
		while (hull.size() >= 2 && !check(hull[hull.size() - 2], hull[hull.size() - 1], v[i]))
			hull.pop_back();
		hull.push_back(v[i]);
	}

	ld ans = 0;
	for (int i = 0; i < hull.size(); ++i)
		ans += (hull[i] - hull[(i + 1) % hull.size()]).len();

	cout << std::fixed << std::setprecision(30) << ans;


	return 0;
}


