#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include <chrono>
#include <set>
#include <map>

using namespace std;

//#define int long long
const int N = 2 * (100000 + 7);
vector<int> dsu_prev(N, -1);
vector<int> dsu_rank(N, -1);

int dsu_get(int v) {
    if (dsu_prev[v] == -1) {
        return v;
    }

    int res = dsu_get(dsu_prev[v]);
    dsu_prev[v] = res;
    return res;
}

bool dsu_same(int v, int u) {
    return dsu_get(v) == dsu_get(u);
}

void dsu_merge(int v, int u) {
    v = dsu_get(v);
    u = dsu_get(u);

    if (dsu_rank[v] > dsu_rank[u]) {
        dsu_rank[v] += dsu_rank[u];
        dsu_prev[u] = v;
    } else {
        dsu_rank[u] += dsu_rank[v];
        dsu_prev[v] = u;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    int v_new_next = n;

    vector<int> color(n);
    for (int i = 0; i < n; ++i) {
        color[i] = i;
    }

    vector<pair<int, int>> res_edges;

    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        if (!dsu_same(v, u)) {
            dsu_merge(v, u);
            res_edges.emplace_back(v, u);
        } else {
            int v_new = v_new_next;
            v_new_next++;
            color.push_back(color[u]);

            res_edges.emplace_back(v, v_new);
        }
    }

    cout << color.size() << '\n';
    for (int i = 0; i < color.size(); ++i) {
        cout << color[i] + 1 << ' ';
    }
    cout << '\n';
    for (auto e : res_edges) {
        cout << e.first + 1 << ' ' << e.second + 1 << '\n';
    }

    return 0;
}