#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <algorithm>
#include <queue>
#include <ctime>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <random>
#include <chrono>
#include <list>
using namespace std;

//#define int ll

typedef long long ll;
typedef long double ld;
typedef pair <int , int> pii;
typedef pair <ll , ll> pll;


#define ff first
#define ss second
#define mp make_pair
#define pf push_front
#define pb push_back
#define IO ios_base::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
#define print(x) { for (auto xxxxxxxxx : (x)) cout << xxxxxxxxx << ' '; cout << '\n'; }
#define printp(x) { for (auto xxxxxxxxx : (x)) cout << "{" << xxxxxxxxx.ff << ", " << xxxxxxxxx.ss << "} "; cout << '\n'; }
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const ll mod=1e9+7;
const ll inf=2e18+5;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll random(ll l, ll r){ return uniform_int_distribution<ll>(l, r)(rng);}

struct pt {
    ll x, y;
};
bool cmp (pt a, pt b) {
    return a.x < b.x || a.x == b.x && a.y < b.y;
}
bool cw (pt a, pt b, pt c) {
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) < 0;
}
bool ccw (pt a, pt b, pt c) {
    return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y) > 0;
}
void convex_hull (vector<pt> & a) {
    if (a.size() == 1) return;
    sort (a.begin(), a.end(), &cmp);
    pt p1 = a[0], p2 = a.back();
    vector<pt> up, down;
    up.push_back (p1);
    down.push_back (p1);
    for (size_t i=1; i<a.size(); ++i) {
        if (i==a.size()-1 || cw (p1, a[i], p2)) {
            while (up.size()>=2 && !cw (up[up.size()-2], up[up.
                    size()-1], a[i]))
                up.pop_back();
            up.push_back (a[i]);
        }
        if (i==a.size()-1 || ccw (p1, a[i], p2)) {
            while (down.size()>=2 && !ccw (down[down.size()-2],
                                           down[down.size()-1], a[i]))
                down.pop_back();
            down.push_back (a[i]);
        }
    }
    a.clear();
    for (size_t i=0; i<up.size(); ++i)
        a.push_back (up[i]);
    for (size_t i=down.size()-2; i>0; --i)
        a.push_back (down[i]);
}

pll operator-(const pll &a , const pll &b) {
    return pll(a.first - b.first , a.second - b.second);
}

ll CrossProduct(pll a , pll b) {
    return a.first*b.second - a.second*b.first;
}

vector <pll> convexHull(vector <pll> a) {
    sort(all(a));
    pll st = a[0];
    sort(1 + all(a) , [st](const pll &a , const pll &b) {
        return CrossProduct(a - st , b - st) > 0;
    });
    a.push_back(st);
    vector <pll> ch;
    int n = a.size();
    for (int i = 0; i < n; i++) {
        int sz = ch.size();
        while (ch.size() > 1 && (CrossProduct(ch[sz - 1] - ch[sz - 2] , a[i] - ch[sz - 2]) <= 0)) {
            sz--;
            ch.pop_back();
        }
        ch.push_back(a[i]);
    }
    return ch;
}

ld dist(pt x , pt y) {
    pll a = {x.x , x.y};
    pll b = {y.x , y.y};
    return sqrt(ld((a.first - b.first)*(a.first - b.first) + (a.second - b.second)*(a.second - b.second)));
}

void solve(){
    int n , l; cin >> n >> l;
    vector <pt> a(n);
    for (auto &x : a)
        cin >> x.x >> x.y;
    convex_hull(a);
    /*
    for (auto x : a) {
        cout << x.first << ' ' << x.second << '\n';
    }
    */
    vector <pt> b;
    for (auto x : a) {
        b.pb({x.x + l , x.y});
        b.pb({x.x - l , x.y});
        b.pb({x.x + 0 , x.y + l});
        b.pb({x.x + 0 , x.y - l});
    }

    convex_hull(b);
    b.push_back(b[0]);
    ld ans = 0;
    for (int i = 0; i + 1 < b.size(); i++) {
        //cout << b[i].x << ' ' << b[i].y << '\n';
        ans += dist(b[i] , b[i + 1]);
    }
    cout.precision(20);
    cout << ans << '\n';
}
/*
9 0
1 1
3 1
5 1
5 2
3 2
3 3
2 3
2 2
1 2

4 3
-3 -3
-3 3
3 3
3 -3

 */
signed main() {
    IO
    //freopen(".in" , "r" , stdin);freopen(".out" , "w" , stdout);
    int t=1;
    //cin >> t;
    while(t--) solve();
}