#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <deque>
#include <algorithm>
#include <queue>
#include <ctime>
#include <unordered_set>
#include <unordered_map>
#include <cassert>
#include <random>
#include <chrono>
#include <list>
using namespace std;

//#define int ll

typedef long long ll;
typedef long double ld;
typedef pair <int , int> pii;


#define ff first
#define ss second
#define mp make_pair
#define pf push_front
#define pb push_back
#define IO ios_base::sync_with_stdio(false);cin.tie(NULL);cout.tie(NULL);
#define print(x) { for (auto xxxxxxxxx : (x)) cout << xxxxxxxxx << ' '; cout << '\n'; }
#define printp(x) { for (auto xxxxxxxxx : (x)) cout << "{" << xxxxxxxxx.ff << ", " << xxxxxxxxx.ss << "} "; cout << '\n'; }
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

const ll mod=1e9+7;
const ll inf=2e18+5;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
ll random(ll l, ll r){ return uniform_int_distribution<ll>(l, r)(rng);}

struct node{
    int l , r;
    int c, step;
    node() {
        l = r = c = step = 0;
    }
};

int n , N = 1;
vector <node> tree;

void build() {
    while (N < n)
        N *= 2;
    tree.resize(2*N);
    tree[1].l = 0 , tree[1].r = N;
    for (int i = 1; i < 2*N; i++) {
        int mid = (tree[i].l + tree[i].r) / 2;
        if (i*2 + 1 < 2*N) {
            tree[i * 2].l = tree[i].l;
            tree[i * 2].r = mid;
            tree[i * 2 + 1].l = mid;
            tree[i * 2 + 1].r = tree[i].r;
        }
    }
}

void push(int v) {
    if (v*2 + 1 < 2*N) {
        tree[v * 2].c += tree[v].c;
        tree[v * 2].step += tree[v].step;
        tree[v * 2 + 1].c += tree[v].c + (tree[v * 2].r - tree[v * 2].l) * tree[v].step;
        tree[v * 2 + 1].step += tree[v].step;
    }
    tree[v].c = tree[v].step = 0;
}

int inter(int l1 , int r1 , int l2 , int r2) {
    return max(0 , min(r1 , r2) - max(l1 , l2));
}

void modify(int L , int R , int l , int r , int i , int c , int step) {
    //cout << l << ' ' << r << ' ' << i << endl;
    if (r <= L || R <= l)
        return;
    if (L <= l && r <= R) {
        tree[i].c += c;
        tree[i].step += step;
        return;
    }
    push(i);
    int mid = (l + r) / 2;
    modify(L , R , l , mid , i*2, c , step);
    modify(L , R , mid , r , i*2 + 1 , c + inter(L , R , tree[i*2].l , tree[i*2].r) , step);
}

int query(int id , int l , int r , int i) {
    if (r - l == 1) {
        return tree[i].c;
    }
    //cout << id << ' ' << l << ' ' << r << ' ' << i << '\n';
    push(i);
    int mid = (l + r) / 2;
    if (id < mid)
        return query(id , l , mid , i*2);
    else
        return query(id , mid , r , i*2 + 1);
}

pii query(int id) {
    int d = query(id , 0 , N , 1);
    //cout << d << '\n';
    return {id - d , d};
}

void solve(){
    int q; cin >> n >> q;
    build();
    //cout << "asdsa" << '\n';

    while (q --> 0) {
        int t; cin >> t;
        if (t == 1) {
            int l , r; cin >> l >> r; l-- , r--;
            pii f = query(l) , s = query(r);
            if (f.first == s.first) {
                modify(l , r + 1 , 0 , N , 1 , 0 , -1);
            } else {
                modify(l , r + 1 , 0 , N , 1 , 0 , 1);
            }
        } else {
            int id; cin >> id; id--;
            pii ans = query(id);
            cout << ans.first + 1 << ' ' << ans.second << '\n';
        }

        for (int i = 1; i < 2*N; i++) {
            //cout << tree[i].c << ' ' << tree[i].step << ' ' << tree[i].l << ' ' << tree[i].r << '\n';
        }

    }
}
/*
6 8
1 2 5
2 5
1 3 4
2 4
1 2 3
2 6
1 6 6
2 1

7 7
1 3 6
1 3 4


 */
signed main() {
    //IO
    //freopen(".in" , "r" , stdin);freopen(".out" , "w" , stdout);
    int t=1;
    //cin >> t;
    while(t--) solve();
}