#include <iostream>
#include <algorithm>
#include <vector>
#include <stack>
#include <queue>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <cmath>
#include <deque>

using namespace std;

typedef long long ll;
typedef pair<int, int> point;
#define x first
#define y second

template <class T = int>
T next() { T x; cin >> x; return x; }

long double sdist(point p1, point p2)
{
    return sqrt(((long double)p1.x - p2.x) * ((long double)p1.x - p2.x) + ((long double)p1.y - p2.y) * ((long double)p1.y - p2.y));
}

ll prod(point p0, point p1, point p2)
{
    point p11 = { p1.x - p0.x, p1.y - p0.y };
    point p22 = { p2.x - p1.x, p2.y - p1.y };
    return (ll)p11.x * (ll)p22.y - (ll)p11.y * (ll)p22.x;
}

long double special_func(vector<point>& points)
{
    point p = points[0];

    for (int i = 0; i < points.size(); i++)
        if (points[i] < p)
            p = points[i];

    for (int i = 0; i < points.size(); i++)
        points[i] = { points[i].x - p.x, points[i].y - p.y };

    sort(points.begin(), points.end(),
        [](const point& p1, const point& p2)
        {
            return atan2(p1.y, p1.x) < atan2(p2.y, p2.x);
        });

    vector<point> shell = { point(0, 0) };
    shell.reserve(points.size());

    for (int i = 0; i < points.size(); i++)
    {
        int n = shell.size();
        while (shell.size() > 1 && prod(shell[n - 2], shell[n - 1], points[i]) <= 0)
        {
            shell.pop_back();
            n--;
        }

        shell.push_back(points[i]);
    }

    shell.push_back(shell.front());

    long double dist = 0;
    for (int i = 0; i < shell.size() - 1; i++)
        dist += sdist(shell[i], shell[i + 1]);

    return dist;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout.precision(20);

    int n, l, x, y;
    cin >> n >> l;
    std::vector<pair<int, int>> pts;
    pts.reserve(n * 4);
    while (n--)
    {
        cin >> x >> y;
        pts.emplace_back(x, y + l);
        pts.emplace_back(x, y - l);
        pts.emplace_back(x - l, y);
        pts.emplace_back(x + l, y);
        //pts.emplace_back(x, y);
    }
    std::cout << special_func(pts);

    return 0;
}