#include <iostream>
#include <set>
#include <map>
#include <vector>

struct Edge {
	int u;
	int w;
};

vector <int> par(2e5 + 113, -1);
vector <int> d(2e5 + 113, 0);
set <pair<int,int>> gr, ans;

int Get(int v) {
	if (par[v] == v) return v;
	return par[v] = Get(par[v]);
}

bool Union(int u, int v) {
	u = Get(u);
	v = Get(v);

	if (u != v) {
		if (d[u] > d[v]) swap(u, v);
		par[u] = v;
		if (d[u] == d[v]) ++d[v];
		return true;
	}
	else {
		return false;
	}
}

int n, m;

using namespace std;

int main() {
	cin >> n >> m;
	while (m--) {
		int u, v;
		cin >> u >> v;
		gr.insert({ u, v });
		if (Union(u, v)) {
			ans.insert({ u, v });
		}
	}

	vector <int > colors(n + 1);
	for (int i = 1; i <= n; ++i)
		colors[i] = i;

	for (auto it = ans.begin(); it != ans.end(); ++it) {
		cout << it.first << ' ' << it.second << '\n';
	}
}