#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
#include <cmath>
#include <math.h>
#include <vector>

using namespace std;

vector<int> par(2e5 + 113, -1);
vector<int> d(2e5 + 113, 0);
set <pair<int, int> > gr, ans;

int Get(int v) {
	if (par[v] == v) return v;
	return par[v] = Get(par[v]);
}

bool Union(int u, int v) {
	u = Get(u);
	v = Get(v);

	if (u != v) {
		if (d[u] > d[v]) {
			int tmp = d[v];
			d[v] = d[u];
			d[u] = tmp;
		}
		par[u] = v;
		if (d[u] == d[v]) ++d[v];
		return true;
	}
	else {
		return false;
	}
}

int n, m;
int counter;


int main() {
	cin >> n >> m;

	counter = n;

	for (int i = 1; i <= n; ++i) par[i] = i;

	while (m--) {
		int u, v;
		cin >> u >> v;
		gr.insert({ u, v });
		if (Union(u, v)) {
			ans.insert({ u, v });
		}
	}

	vector <int > colors;
	for (int i = 1; i <= n; ++i)
		colors.push_back(i);

	for (auto it = gr.begin(); it != gr.end(); ++it) {
		pair <int, int> pr = *it;

		if (ans.count(pr) == 0) {
			ans.insert({ pr.first, counter + 1 });
			++counter;
			colors.push_back( colors[pr.second] );
		}
	}

	cout << counter << endl;
	for (int i = 0; i < colors.size(); ++i)
		cout << colors[i] << ' ';
	cout << endl;

	for (auto it = ans.begin(); it != ans.end(); ++it) {
		cout << (*it).first << ' ' << (*it).second << endl;
	}

	return 0;
}