#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <iomanip>
#include <cstdlib>
#include <queue>
#include <deque>
#include <tuple>
#include <cassert>
#include <cstring>

using namespace std;

#define fi first
#define se second
#define int long long


template <typename T,typename S>
istream& operator >>(istream& in, pair<T,S> &m) {
    in >> m.fi >> m.se;
    return in;
}

template <typename T>
istream& operator >>(istream& in, vector<T> &m) {
    for (int i=0,l=m.size();i<l;++i)
        in >> m[i];
    return in;
}

template <typename T,typename S>
ostream& operator <<(ostream& out, pair<T,S> &m) {
    out << m.fi << ' ' << m.se;
    return out;
}

template <typename T>
ostream& operator <<(ostream& out, vector<T> &m) {
    for (int i=0,l=m.size();i<l;++i)
        out << m[i] << ' ';
    return out;
}


void simple_solution(int S, const vector<int>& a)
{
    int n = a.size();
    double S2 = 1.0 * S / 2;
    pair<int, int> p;
    unsigned long long res = 0;
    for (int i = 0; i < n; i++)
    {
        p.first = 0; p.second = 0;
        for (int j = 0; j < n; j++)
        {
            if (j == i)
            {
                continue;
            }
            if (a[j] > a[i] || a[j] <= fmod(a[i] + S2, S))
            {
                if (a[j] == fmod(a[i] + S2, S))
                {
                    p.second++;
                }
                p.first++;
            }
            else
            {
                if (a[j] == fmod(a[i] + S2, S))
                {
                    p.first++;
                }
                p.second++;
            }
        }
        res += p.first * p.second;
    }
    cout << '<' << res / 3 << '>' << endl;
}


struct node {
    vector<int> mas;
    node(int a=0) {
        mas.push_back(a);
    }
};


node operator +(node a, node b) {
    vector<int> res;
    for (int i : a.mas)
        res.push_back(i);
    for (int i : b.mas)
        res.push_back(i);
    sort(res.begin(), res.end());
    node c;
    c.mas = res;
    return c;
}

struct seg_tree {
    vector<node> s;
    vector<int> mas;
    int n;
    seg_tree(vector<int> _mas) {
        mas = _mas;
        n = mas.size();
        s.resize(4*n);
    }

    void build(int l,int r,int v) {
        if (l == r-1) s[v] = node(mas[l]);
        else {
            int m = (l+r)/2;
            build(l,m,v*2+1);
            build(m,r,v*2+2);
            s[v] = s[v*2+1] + s[v*2+2];
        }
    }

    int ask(int l,int r,int lx,int rx,int v, int x) {
        if (r <= lx || rx <= l) {
            return 0;
        }
        if (l >= lx && r <= rx) {
            return s[v].mas.end() - lower_bound(s[v].mas.begin(), s[v].mas.end(), x);
        }
        int m = (l+r)/2;
        return ask(l,m,lx,rx,v*2+1, x) + ask(m,r,lx,rx,v*2+2, x);
    }

};


void solution() {
    int n;
    cin >> n;
    vector<int> l(n);
    cin >> l;
    vector<int> dp((int)1e6+1);
    dp[0] = 1;
    sort(l.begin(), l.end());
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= sum; ++j) {
            dp[l[i] + j] |= dp[j];
        }
        sum += l[i];
    }
    //for (int i = 0; i <= sum;++i) cout << dp[i] << ' ';
    int ans = 0;
    for (int i = 0; i <= sum; ++i) {
        if (dp[i]) {
            ans += sum-i+1;
        }
    }
    vector<int> ss(sum+2);
    for (int i = 0; i <= sum; ++i) {
        if (dp[i]) {
            ss[i] = sum-i+1;
        }
    }
    ans = ans+ans;
    //cout << ans;
//for (int i : ss) cout << i << ' '; cout << endl;
    seg_tree s(ss);
    s.build(0, sum+2, 0);

    for (int i = 0; i <=sum; ++i) {
        if (dp[i]) {
            ans -= s.ask(0, sum+2, 0, i+1, 0, sum-i+1);
        }
    }
    cout << ans;
}

int32_t main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solution();
}




/*
                                                              ..---..._
                                                        ..--""         "-.
                                                   ..-"""                 ".
                                               ..-""                        "
                                            .-"
                                         .-"      ... -_
                                     .="   _..-" F   .-"-.....___-..
                                     "L_ _-'    ."  j"  .-":   /"-._ "-
                                        "      :  ."  j"  :   :    |"" ".
                                  ......---------"""""""""""-:_     |   |\
                        ...---""""                             -.   f   | "
                ...---""       . ..----""""""""..                ".-... f  ".
         ..---"""       ..---""""""""-..--"""""""""^^::            |. "-.    .
     .--"           .mm::::::::::::::::::::::::::...  ""L           |x   ".
   -"             mm;;;;;;;;;;XXXXXXXXXXXXX:::::::::::.. |           |x.   -
 xF        -._ .mF;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXX:::::::|            |X:.  "
j         |   j;;;;;XXX#############################::::::|            XX::::
|          |.#;::XXX##################################::::|            |XX:::
|          j#::XXX#######################################::             XXX::
|         .#:XXX###########################################             |XX::
|         #XXX##############################XX############Fl             XXX:
|        .XXX###################XX#######X##XXX###########Fl             lXX:
 |       #XX##################XXX######XXXXXXX###########F j             lXXX
 |       #X#########X#X#####XXX#######XXXXXX#######XXX##F  jl            XXXX
 |       #X#######XX#"  V###XX#' ####XXXXXX##F"T##XXXXXX.  V   /  .    .#XXXX
  |       #########"     V#XX#'  "####XXXX##.---.##XXXXXX.    /  /  / .##XXXX
  |       "######X' .--"" "V##L   #####XXX#"      "###XXXX. ."  /  / .###XXXX
  |         #####X "   .m###m##L   ####XX#      m###m"###XX#   /  / .#####XXX
   |         "###X   .mF""   "y     #####     mX"   "Y#"^####X   / .######XXX
   |           "T#   #"        #     ####    X"       "F""###XX"###########XX
   |             L  d"     dXX  xm   "^##L mx     dXX  YL-"##XX"S""##########
    |            xL J     Xd%    T      ""  T    XdX    L. "##XS.f |#########
    |             BL      X## X                  X## X      T#SS"  |#########
    |              #L     X%##X                  X%##X|     j#SSS /##########
     |              #L  ._ TXXX-"           "-._  XXXF.-    ###SS\###########
     |              ##   """""                  """"""      ##DS.\###########
     |              TF                                      ##BBS.T#########F
      |             #L           ---                        ###BBS.T########'
      |            '##            ""                     jL|###BSSS.T#######
       |          '####             ______              .:#|##WWBBBSS.T####F
      J L        '######.            \___/            _c::#|###WWWBSSS|####
     J ;;       '########m                           c:::'#|###WWWBBSS.T##"
    J ;;;L      :########.:m.          _          _cf:::'.L|####WWWWSSS|#"
  .J ;;;;B      ########B....:m..             _,c%%%:::'...L####WWWBBSSj
 x  ;;;;dB      #######BB.......##m...___..cc%%%%%::::'....|#####WWBBDS.|
" ;;;;;ABB#     #######BB........##j%%%%%%%%%%%%%%:::'..... #####WWWWDDS|
.;;;;;dBBB#     #######BB.........%%%%%%%%%%%%%%%:::'...   j####WWWWWBDF
;;;;;BBB####    ######BBB.........%%%%%%%%%%%%%%:::'..     #####WWWWWWS
;;;;dBBB####    ######BBB..........^%%%%%%%%%%:::"         #####WWWWWWB
;;;:BBB######   X#####BBB"..........."^YYYYY::"            #####WWWWWWW
;;.BB#########  X######BBB........:''                      #####WWWWWWW
;;BB##########L X######BBB.......mmmm..                 ..x#####WWWWWWB.
;dBB########### X#######BB.....        "-._           x""  #####WWWWWWBL
;BBB###########L X######BB...              "-              ######WWWWBBBL
BBB#############. ######BBB.                                #####WWWWBBBB
BBB############## X#####BBB                                 #####WWWWWBBB
BBB############### T#####BB                                  #####WWWBBB     :
BB################# T###BBP                                   #####WWBB"    .#
BB##################..W##P                                      ###BBB"    .##
BB###################..l                                         "WW"      ###
BB####################j ___                                        " l    j###
BBB##################J_-   """-..             ':::'   .-""""""""""-.  l  .####
BBB######B##########J########    "-.           ::'  -" ..mmm####mm.."-.< #####
MCL-5/7/88 BBB#####J############    "-_        :|  " .###############mmLlR####
BBBBBBBBBBBBBBB###/         #######    -.     .:| ".#####F^^^P^^"""^^^Y#lT####
BBBBBBBBBBBBBBBBBj|####mm        ######xx-...:::|" ###f      .....      "#T###
BBBBBBBBBBBBBBBBjj##########mm..           ":::."j##F  .mm#########mmm.. Yj###
BBBBBBBBBBBBBBBB|^WWWSRR############mmmmm xx """mjF.mm####################j###
BBBBBBBBBBBBBBBB|                      ######mmmmmm#######################j###
BBBBBBBBBBBBBBBBY#m...   ..mmm##########PPPPP#####m..                    lj###
BBBBBBBBBBBBBBBBB2##############^^""     ..umF^^^Tx ^##mmmm........mmmmmmlj###
BBBBBBBBBBBBBBBBBJT######^^^""     .mm##PPPF"...."m.  "^^###############lj####
BBBBBBBBBBBBBBBBB##^L         .mmm###PPP............"m..    """"^^^^^"" lj####
BBBBBBBBBBBBBBBB#####Y#mmx#########P.................."^:muuuummmmmm###^.#####
BBBBBBBBBBBBBBBB#####::Y##mPPPPF^".......|.............. ""^^######^^"...#####
BBBBBBBBBBBBBB########..................F............      \     ........#####
BBBBBBBBBBBBB#########.................|..........          :       ....l#####
BBBBBBBBBBBB###########...............F.........             \        ..######
BBBBBBBBBBB#############.............|........                :         dA####
BBBBBBBBBB##############.....................                           kM####
BBBBBBBBB################..................                             k#####
BBBBBBB##################................                               k#####
BBBBB#####################.............                                 t#####
BB########################............                                  "E####
B########################F............                           .       "####
#########################............'      |                    ..       "L##
########################F............                           ...        "L#
#######################F............'                           .....       "#
######################F.............                           .......       "
#####################$..............                         .........
#####################lmmm.............                      ...........   ..m#
####################j########mmmm.............            ......mmmmmm########
###################j###::::;:::::########mmmmmmm##############################
##################j:::::::;:::::::;;::##############################^^^""""
##################.mm:::mmm######mmmm:::' ^^^^^^""#######^^""""
#################F...^m::;::################mmm  .mm"""
#################.......m;::::::::::::#########^"
################F.........###mmm::::;' .##^"""
 ##############F...........:#######m.m#"
   ############..............':####
     #########F............mm^""
       #######..........m^""
          ####.......%^"
             #.....x"
             |.x""
            .-"
          .-
        .-
      .-
     -
   -"
 -"
"
                                                                             x
                                                                           xx
                                                                         xx
                                                                     xxx"
                                                                 xxx"
                                                           .xxxx"
                                                   ___xxx""
                                             .xxxx""....F
                """"mmxxxxx          ___xxx^^^..........'
                   .xx^^^^YYYY###xxx^^.................|
                .xx^"        #######x..................|
             .xx"          ###########mx..............f
           .x^            ##############xx............|
          j"             ##############    x..........;
.........#              ############       #x.........|
x.......j"              ##########       ####x.......f
 xxx....#..            ########        #######x......|
   xxxx.#....         #######        ##########x.....|
      xxx......       #####         #########   x....|
         xxx......    ###          #######      #m...|
           xxx......  ##           ######      ####..|
             xxx......#.          #####       ######m|
               xxxx.......        ###        #######Fx
                   xxx......      #         j#####    m
                      xx......              ####      Jxm
                       xxx......           ####      j###Km
                          xxx.....         ###      j####F  m
                             xx......       #       ###F    .m
                               xxx ....            j##F    .###m
                               m..xx.....          ##F    j#####K^mm.
                                m...xx......       ##     #####F    ####mm
                                m .....x......     F     j####F    ########
                                 m  ......x.....         ###F    J##########
                                 "m  ........x....      .#F     #########^^|
                                  "......mmF^^^x....    ##     ######      |
                                   lL..jF        x.... .F      ####       |
                                   lTLJF           x....      ####        |
                                   l::|.            "....    j###       ##
                                    l....            L....   ###F     x##
                                     l....       ..m##L...   ##F     j###
                                     l:...        #####L...  #F     j####
                                      l....    ####     ...        #####
                                      "....              ...       ####F |
                                       l....              ...     j###F  |
                                        #...               ....   ###F    |
                                        "#..              .jL.... ##F     |
                                         ##.            .m###L....#F      |
                                         "##        ..mm###### ....       |
                                          |                   |...        |
                                          k                    |...       |
                                          l                    |...       k
                                           k                 .m#L...     Jk
                                           ##            ..mm####L...     k
                                           ###         d########' L....   |
                                           l                   |   "-.__-"
                                           l                   |
                                           l                  j#
                                           :                 j##
                                            k               j##'
                                            l            .m###k
                                            l           ###^^"|
                                            |                 |
                                            j               .##
                                            |              ######
                                            |==          ##### ####
                                           .k          #####"   ####
                                           l         #####^     ####
                                           l       ###         ####'
                                           !                 m###F
                                           |               ######
                                           |           mm##m###'
                                           |.       m########F
                                           |.    m#######F" #
                                           d.   ###        #
                                          |..             .'
                                          |..             |
                                           k..           :
                                           \...          F
                                            |...        #d
                                            |...       ###
                                             L...     ####.
                                             |...    j### |
                                              L...   ###  |
                                              T...  j##    k
                                               \... ##     |
                                                 \...      .
                                                   "^-____-
*/