#include <bits/stdc++.h>
#define X real()
#define Y imag()

using namespace std;

typedef complex< long double > point;
typedef complex< long double > my_vector;

long double oblique(my_vector a, my_vector b) {
    return (a.X * b.Y - a.Y * b.X);
}

long double length(point a, point b) {
    return sqrt((b.X - a.X) * (b.X - a.X) + (b.Y - a.Y) * (b.Y - a.Y));
}

int main() {
    int n;
    long double l;
    cin >> n >> l;
    vector< pair< long double, long double > > v;
    for (int i = 1; i <= n; i++) {
        long double x;
        long double y;
        cin >> x >> y;
        v.push_back({x + l, y});
        v.push_back({x - l, y});
        v.push_back({x, y - l});
        v.push_back({x, y + l});
    }
    pair< long double, long double > p[v.size() + 5];
    for (int i = 0; i < v.size(); i++)
        p[i + 1] = v[i];
    n = v.size() - 1;
    sort(p + 1, p + n + 1);
    point a = {p[1].first, p[1].second};
    point b = {p[n].first, p[n].second};
    deque< point > s1;
    deque< point > s2;
    s1.push_back(a);
    s2.push_back(a);
    for (int i = 1; i <= n; i++) {
        point x = {p[i].first, p[i].second};
        my_vector ax = x - a;
        my_vector ab = b - a;
        if (oblique(ax, ab) < 0)
            s1.push_back(x);
        else if (oblique(ax, ab) > 0)
            s2.push_back(x);
    }
    s1.push_back(b);
    s2.push_back(b);
    vector< point > upper;
    upper.push_back(s1[0]);
    upper.push_back(s1[1]);
    for (int i = 2; i < s1.size(); i++) {
        point x = s1[i];
        a = upper.back();
        b = upper[upper.size() - 2];
        my_vector xa = a - x;
        my_vector xb = b - x;
        while (upper.size() >= 2 && oblique(xa, xb) <= 0) {
            a = b;
            upper.pop_back();
            if (upper.size() >= 2)
                b = upper[upper.size() - 2];
            else
                break;
            xa = a - x;
            xb = b - x;
        }
        upper.push_back(x);
    }
    vector< point > lower;
    lower.push_back(s2[0]);
    lower.push_back(s2[1]);
    for (int i = 2; i < s2.size(); i++) {
        point x = s2[i];
        a = lower.back();
        b = lower[lower.size() - 2];
        my_vector xa = a - x;
        my_vector xb = b - x;
        while (lower.size() >= 2 && oblique(xa, xb) >= 0) {
            a = b;
            lower.pop_back();
            if (lower.size() >= 2)
                b = lower[lower.size() - 2];
            else
                break;
            xa = a - x;
            xb = b - x;
        }
        lower.push_back(x);
    }
    long double ans = 0;
    for (int i = 1; i < upper.size(); i++)
        ans += length(upper[i - 1], upper[i]);
    for (int i = 1; i < lower.size(); i++)
        ans += length(lower[i - 1], lower[i]);
    cout << fixed << setprecision(15) << ans;
    return 0;
}
