#include<bits/stdc++.h>

#define ll long long
#define ld long double
#define fi first
#define y1 firssadt
#define se second
#define pb push_back
#define pk pop_back

using namespace std;

struct point {
    double x, y;
};

long double get_length(long double x1, long double y1,long double x2, long double y2){
    long double a = abs(x1 - x2),
            b = abs(y1 - y2);

    return sqrt(pow(a, 2) + pow(b, 2));
}

bool cmp (point a, point b) {
    return (a.x < b.x || a.x == b.x && a.y < b.y);
}

bool cw (point a, point b, point c) {
    return (a.x * (b.y - c.y) + b.x * (c.y - a.y) + c.x * (a.y - b.y) < 0);
}

bool ccw (point a, point b, point c) {
    return (a.x * (b.y - c.y) + b.x * (c.y - a.y) + c.x * (a.y - b.y) > 0);
}

void convex_hull (vector< point > & a) {
    if (a.size() == 1)
        return;
    sort(a.begin(), a.end(), &cmp);
    point p1 = a[0];
    point p2 = a.back();
    vector< point > up;
    vector< point > down;
    up.push_back(p1);
    down.push_back(p1);
    for (size_t i = 1; i < a.size(); i++) {
        if (i == a.size() - 1 || cw(p1, a[i], p2)) {
            while (up.size() >= 2 && !cw(up[up.size() - 2], up[up.size() - 1], a[i]))
                up.pop_back();
            up.push_back(a[i]);
        }
        if (i == a.size() - 1 || ccw(p1, a[i], p2)) {
            while (down.size() >= 2 && !ccw (down[down.size() - 2], down[down.size() - 1], a[i]))
                down.pop_back();
            down.push_back(a[i]);
        }
    }
    a.clear();
    for (size_t i = 0; i < up.size(); i++)
        a.push_back(up[i]);
    for (size_t i = down.size() - 2; i > 0; i--)
        a.push_back(down[i]);
}

int main() {
    int n;
    long double l;
    cin >> n >> l;
    vector< point > a;
    for (int i = 1; i <= n; i++) {
        long double x1;
        long double y1;
        cin >> x1 >> y1;
        a.push_back({x1 + l, y1});
        a.push_back({x1 - l, y1});
        a.push_back({x1, y1 + l});
        a.push_back({x1, y1 - l});
    }
    convex_hull(a);
    long double ans = 0;
    for (int i = 0; i < a.size() - 1; i++)
        ans += get_length(a[i].x, a[i].y, a[i + 1].x, a[i + 1].y);
    ans += get_length(a[a.size() - 1].x, a[a.size() - 1].y, a[0].x, a[0].y);
    cout << setprecision(15) << ans;
    return 0;
}
