#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

vector<vector<int>> gr;
vector<bool> used;
set<pair<int, int>> correct_gr;
set<pair<int, int>> correct_gr2;
vector<int> vertexes;

void dfs(int v, int p) {
    if (p != v) {
        pair<int, int> now;
        now.first = min(v, p);
        now.second = max(v, p);
        if (correct_gr.find(now) == correct_gr.end()) {
            correct_gr.insert(now);
            int t = vertexes.size();
            now.first = min(t, p);
            now.second = max(t, p);
            correct_gr2.insert(now);
            vertexes.push_back(v + 1);
        }
    }
    if (!used[v]) {
        used[v] = true;
        for (auto u : gr[v])
            dfs(u, v);
    }
}

int main()
{
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    used.resize(n, false);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        gr[a - 1].push_back(b - 1);
        gr[b - 1].push_back(a - 1);
    }
    vertexes.push_back(1);
    dfs(0, 0);
    cout << vertexes.size() << "\n";
    for (auto u : vertexes)
        cout << u << " ";
    cout << "\n";
    int k = correct_gr2.size();
    for (int i = 0; i < k; i++) {
        pair<int, int> r = *correct_gr2.begin();
        cout << r.first + 1 << " " << r.second + 1 << "\n";
        correct_gr2.erase(r);
    }
}