#include <bits/stdc++.h>

#define L(V) ((V) * 2 + 1)
#define R(V) ((V) * 2 + 2)

typedef long long ll;
typedef long double ld;

using namespace std;

ll build(vector<ll> &t, ll v, ll vl, ll vr) {
    if (vr == vl + 1) return t[v] = 1;
    else {
        ll vm = (vl + vr) / 2;
        return t[v] = build(t, L(v), vl, vm) + build(t, R(v), vm, vr);
    }
}

ll apply(vector<ll> &t, vector<ll> &d, ll v, ll vl, ll vr) {
    return t[v] + d[v] * (vr - vl);
}

void push(vector<ll> &t, vector<ll> &d, ll v, ll vl, ll vr) {
    t[v] = apply(t, d, v, vl, vr);
    if (vr != vl + 1) {
        d[L(v)] += d[v];
        d[R(v)] += d[v];
    }
    d[v] = 0;
}

ll query(vector<ll> &t, vector<ll> &d, ll l, ll r, ll v, ll vl, ll vr) {
    if (r <= vl || vr <= l) return 0;
    push(t, d, v, vl, vr);
    if (l <= vl && vr <= r) return t[v];
    else {
        ll vm = (vl + vr) / 2;
        return query(t, d, l, r, L(v), vl, vm) + query(t, d, l, r, R(v), vm, vr);
    }
}

void update(vector<ll> &t, vector<ll> &d, ll l, ll r, ll x, ll v, ll vl, ll vr) {
    if (r <= vl || vr <= l) return;
    if (l <= vl && vr <= r) d[v] += x;
    else {
        push(t, d, v, vl, vr);
        ll vm = (vl + vr) / 2;
        update(t, d, l, r, x, L(v), vl, vm);
        update(t, d, l, r, x, R(v), vm, vr);
        t[v] = apply(t, d, L(v), vl, vm) + apply(t, d, R(v), vm, vr);
    }
}

const ll N = 1e6 + 1;

vector<ll> a;

int main() {
    ll n;
    cin >> n;
    a.resize(n);
    ll s = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        s += a[i];
    }
    bitset<N> k(0);
    k[N - 1] = 1;
    for (int i = 0; i < n; ++i) {
        k = k | (k >> a[i]);
    }
    ll k2 = k.count();
    cout << (s + 1)*k2 - (k2-1)*k2/2;
}