// #pragma GCC optimize("O3,unroll-loops,fast-math,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt")
// #pragma GCC target("avx,avx2")
// #define INTER

#include <bits/stdc++.h>

//----------------------------------------------------------------
typedef long long ll;
typedef long double ld;
typedef std::pair<ll, ll> pll;
typedef std::pair<int, int> pii;

std::random_device rd;
std::mt19937 Random(rd());
const int inf = 0x3f3f3f3f;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
const ld eps = 1e-15;
const ll mod = 998244353;

//----------------------------------------------------------------
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define fast_io std::ios::sync_with_stdio(false), std::cin.tie(0), std::cout.tie(0), std::cerr.tie(0);
#define debug(x) std::cerr << #x << ": " << x << '\n'
#define PROBLEM "task"
#define mp std::make_pair

template<typename T, typename T1>
inline T mx(T &a, T1 b) { return (a > b ? a : a = b); }
template<typename T, typename T1>
inline T mn(T &a, T1 b) { return (a < b ? a : a = b); }
//----------------------------------------------------------------

using namespace std;

struct point {
    ll x, y;

    point() :x(0), y(0) {}
    point(ll x, ll y) :x(x), y(y) {}

    point operator-(point p) { //get vector
        return point(x - p.x, y - p.y);
    }

    ll operator%(point p) { //scalar
        return x*p.x + y*p.y;
    }

    ll operator^(point p) { //pseudiscalar
        return x*p.y - p.x*y;
    }

    ll sqrLen() {
        return *this % *this;
    }

    double len() {
        return sqrt(sqrLen());
    }

    bool operator<(const point& p)const {
        return x < p.x || (x == p.x&&y < p.y);
    }
};

bool isUp(point b, point v) {
    return (b ^ v) >= 0;
}

bool isDown(point b, point v) {
    return (b ^ v) <= 0;
}

double len(vector<point> a) {
    double l = 0;

    for (ll i = 0; i < a.size() - 1; i++) {
        l += (a[i + 1] - a[i]).len();
    }

    return l;
}

int32_t main() {
#ifndef DEBUG
    #ifndef INTER
    fast_io;
#endif
#else
    freopen(PROBLEM".in", "r", stdin);
#endif

    std::cout << std::setprecision(15) << std::fixed;
    std::cerr << std::setprecision(15) << std::fixed;
    long double START_TIME = clock();

    ll n, l; cin >> n >> l;
    vector<point> a;

    for (ll i = 0; i < n; i++){
        ll x, y; cin >> x >> y;
        a.push_back({x - l, y});
        a.push_back({x + l, y});
        a.push_back({x, y - l});
        a.push_back({x, y + l});
    }

    sort(a.begin(), a.end());
    n = a.size();

    point border = a[n - 1] - a[0];
    vector<point> up, down;

    up.push_back(a[0]);
    down.push_back(a[0]);

    for (ll i = 1; i < n; i++) {
        if (isUp(border, a[i] - a[0])) {
            while (up.size() > 1 && isUp(up[up.size() - 1] - up[up.size() - 2], a[i] - up[up.size() - 1])) {
                up.pop_back();
            }

            up.push_back(a[i]);
        }

        if (isDown(border, a[i] - a[0])) {
            while (down.size() > 1 && isDown(down[down.size() - 1] - down[down.size() - 2], a[i] - down[down.size() - 1])) {
                down.pop_back();
            }

            down.push_back(a[i]);
        }
    }

    cout << setprecision(10) << fixed << len(up) + len(down) << endl;

    long double TIME = (clock() - START_TIME) / CLOCKS_PER_SEC;
    // debug(TIME);
    return 0;
}