﻿#include <iostream>
#include <vector>
#include <cmath> 
#include <random>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <queue>
#include <deque>

#define kak_zhe_hochetsya_tyanochku ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define rep(i, n) for (int i = 0; i < n; ++i)
#define cod(x) static_cast<int>(x)
#define all(x) x.begin(), x.end()
#define in(i, a) for(auto i : a)
#define inl(i, a) for(auto& i : a)

using namespace std;

using ll = long long;

const ll INF = 1e18 + 7, MOD = 1e9 + 7;

template <class T> void print(vector<T>& a) {
    for (auto x : a) {
        cout << x << " ";
    }
    cout << "\n";
}

int n, m;
vector<int> deg;
vector<int> p;
vector<pair<int, int>> e;
vector<int> c;
vector<int> r;
vector<pair<int, int>> ans;

int parent(int v) {
    if (p[v] == v) {
        return v;
    }
    return p[v] = parent(p[v]);
}

bool join(int v, int u) {
    v = parent(v);
    u = parent(u);
    if (v == u) {
        return false;
    }
    if (r[v] == r[u]) {
        p[u] = v;
        ++r[v];
    }
    else if (r[v] > r[u]) {
        p[u] = v;
    }
    else {
        p[v] = u;
    }
    return true;
}

int main() {
    kak_zhe_hochetsya_tyanochku;
    cin >> n >> m;
    deg.resize(n);
    p.resize(2 * m);
    rep(i, 2 * m) {
        p[i] = i;
    }
    e.resize(m);
    c.resize(n, 0);
    r.resize(2 * m, 1);
    rep(i, m) {
        int v, u;
        cin >> v >> u;
        e[i] = { v - 1, u - 1 };
        ++deg[v - 1];
        ++deg[u - 1];
    }
    rep(i, n - 1) {
        c[i + 1] = c[i] + deg[i];
    }
    rep(i, m) {
        int v = e[i].first, u = e[i].second;
        ++c[v];
        v = c[v] - 1;
        ++c[u];
        u = c[u] - 1;
        join(v, u);
        ans.push_back({ v, u });
        
    }
    c[0] = 0;
    rep(i, n - 1) {
        c[i + 1] = c[i] + deg[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = c[i]; j < c[i] + deg[i] - 1; ++j) {
            if (join(j, j + 1)) {
                ans.push_back({ j, j + 1 });
            }
        }
    }
    cout << 2 * m << "\n";
    rep(i, n) {
        rep(j, deg[i]) {
            cout << i + 1 << " ";
        }
    }
    cout << "\n";
    in(p, ans) {
        cout << p.first + 1 << " " << p.second + 1 << "\n";
    }
}