#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include <climits>
#include <map>
#include <iomanip>
#include <queue>
#include <random>
#include <ctime>

using namespace std;

#pragma warning (disable: 4996)

const long double EPS = 1e-9;

struct Point {
    double x, y;
    Point() {};
    Point(double x, double y) : x(x), y(y) {};
};

double operator*(Point& a, Point& b) {
    return a.x * b.x + a.y * b.y;
}

double operator^(Point& a, Point& b) {
    return a.x * b.y - a.y * b.x;
}

bool Less(long double d1, long double d2)
{
    return d1 + EPS < d2;
}

long long C(long long n) {
    return n * (n - 1) * (n - 2) / 6;
}

long long d(long long x1, long long x2, long long l) {
    if (x2 < x1)
        return (l - x1 + x2);
    else
        return x2 - x1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    long long n, l;
    cin >> n >> l;
    vector<long long> dist(n);
    for (long long i = 0; i < n; i++)
        cin >> dist[i];
    long long ans = C(n);
    sort(dist.begin(), dist.end());
    long long i2 = 0;
    for (long long i1 = 0; i1 < n; i1++) {
        while ((i2 + 1) % n != i1 && d(dist[i1], dist[(i2 + 1) % n], l) * 2 < l)
            i2++, i2 %= n;
        long long k;
        if (i2 < i1) 
            k = (n - i1) + i2 - 1;
        else
            k = i2 - i1 - 1;
        k++;
        ans -= (k - 1) * k / 2;
    }
    cout << ans;
}