#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include <climits>
#include <map>
#include <iomanip>
#include <queue>
#include <random>
#include <ctime>

using namespace std;

#pragma warning (disable: 4996)

vector<vector<int>> gr;
vector<int> paint;
vector<int> res;
set<pair<int, int>> e;

void dfs(int v, int p) {
	paint[v] = 1;
	for (int i : gr[v]) {
		if (paint[i] == 0)
			dfs(i, v);
		if (paint[i] == 1 && p != i) {
			int x = res.size();
			res.push_back(v);
			e.insert({ i, x });
			e.erase({ i, v });
			e.erase({ v, i });
		}
	}
	paint[v] = 2;
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	srand(time(0));
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	int n, m;
	cin >> n >> m;
	gr.resize(n);
	paint.resize(n, 0);
	res.resize(n, 0);
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		gr[x].push_back(y);
		gr[y].push_back(x);
		e.insert({ x, y });
	}
	for (int i = 0; i < n; i++)
		res[i] = i;
	dfs(0, -1);
	cout << res.size() << "\n";
	for (int i : res)
		cout << i + 1 << " ";
	cout << "\n";
	for (auto p : e)
		cout << p.first + 1 << " " << p.second + 1 << "\n";
}