#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include <climits>
#include <map>
#include <iomanip>
#include <queue>
#include <random>
#include <ctime>

using namespace std;

#pragma warning (disable: 4996)

const long double EPS = 1e-9;

bool Less(long double d1, long double d2)
{
    return d1 + EPS < d2;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif

    int n;
    long double v, u;
    cin >> n >> v >> u;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    sort(a.rbegin(), a.rend());
    long double t = 0;
    int q = 0;
    bool mark = 0;
    for (int i = 0; i < n - 1; i++)
    {
        int r = 1;
        while (i + r < n && a[i + r] == a[i])
            r++;
        if (i + r == n)
            break;
        double T = (r + q) * (a[i] - a[i + r]) / u;
        if (!Less((T + t) * v, a[i + r]))
        {
            t += (a[i] - t * v) * (r + q) / (u + v * (q + r));
            mark = 1;
            break;
        }
        t += T;
        q += r;
    }
    if (!mark)
        t += (a.back() - t * v) * n / (u + v * n);
    cout << fixed << setprecision(10) << t * u;
}