#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>
#include <queue>


using namespace std;


vector <long double> mass;
long double n, v_ice, v_mak;


bool ok(long double x)
{
    long double summ = 0;
    for (int i = 0; i < int(n); i++)
    {
        summ += max((long double)(0), (mass[i] - x * v_ice) / v_mak);
    }
    return (summ <= x + (1e-10));
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG

    long double a;
    cin >> n >> v_ice >> v_mak;
    for (int i = 0; i < int(n); i++)
    {
        cin >> a;
        mass.push_back(a);
    }

    sort(mass.begin(), mass.end());
    long double l = 0, r = 1123456789, m;
    while (r - l >= 0.000000001)
    {
        m = (r + l) / 2;
        if (ok(m))
            r = m;
        else
            l = m;
    }

    cout.precision(12);
    cout << fixed << r * v_mak;
    return 0;
}