#include <iostream>
#include <string>
#include <regex>
#include <numeric>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <complex>

using namespace std;
#define int long long
typedef double ld;

template<typename T1, typename T2>
bool chkmax(T1 &a, T2 b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T1, typename T2>
bool chkmin(T1 &a, T2 b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

int max(int a, int b) { return a > b ? a : b; }

ld sqr(ld a) { return a * a; }

const int INF = 1e18;

#define endl "\n"
#ifdef int
#define IMAX INT64_MAX
#define IMIN INT64_MIN
#else
#define IMAX INT32_MAX
#define IMIN INT32_MIN
#endif

vector<pair<int, int>> res;
bool *vis;
vector<int> *gr;
int *org;

set<pair<int, int>> rd;

void dfs(int v) {
    vis[v] = true;

    for (int g : gr[v]) {
        pair<int, int> p = {min(g, v), max(g, v)};
        if (rd.find(p) != rd.end()) {
            continue;
        }
        rd.insert(p);
        org[g] = res.size();
        res.emplace_back(org[v], g);
    }
    for (int g : gr[v]) {
        if (vis[g]) {
            continue;
        }
        dfs(g);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> _gr[n];
    gr = _gr;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    bool _vis[n];
    memset(_vis, false, sizeof(_vis));
    vis = _vis;
    int _org[n];
    memset(_org, -1, sizeof(_org));
    org = _org;
    org[0] = 0;

    res.emplace_back(-1, 0);
    dfs(0);

    cout << res.size() << endl;
    for (int i = 0; i < (int)res.size(); i++) {
        cout << res[i].second + 1 << (i == (int)res.size() - 1 ? endl : " ");
    }
    for (int i = 1; i < (int)res.size(); i++) {
        cout << res[i].first + 1 << " " << i + 1 << endl;
    }

}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}