#include <iostream>
#include <string>
#include <regex>
#include <numeric>
#include <set>
#include <map>
#include <iomanip>
#include <cmath>
#include <cassert>
#include <complex>

using namespace std;
#define int long long
typedef double ld;
template <typename T1, typename T2>
bool chkmax(T1& a, T2 b) { if (b > a) { a = b; return true; } return false; }
template <typename T1, typename T2>
bool chkmin(T1& a, T2 b) { if (b < a) { a = b; return true; } return false; }
int max(int a, int b) { return a > b ? a : b; }
ld sqr(ld a) { return a * a; }
const int INF = 1e18;

#define endl "\n"
#ifdef int
#define IMAX INT64_MAX
#define IMIN INT64_MIN
#else
#define IMAX INT32_MAX
#define IMIN INT32_MIN
#endif

void solve() {
    int n, v, u;
    cin >> n >> v >> u;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    double l = 0, r = 1e10;
    for (int it = 0; it < 200; ++it) {
        double t = (l + r) / 2;
        double left_part = u * t;
        double right_part = 0;
        for (int i = 0; i < n; ++i) {
            double ti = (a[i] - v * t);
            if (ti >= 0) {
                right_part += ti;
            }
        }
        if (left_part <= right_part) {
            l = t;
        } else {
            r = t;
        }
    }
    cout << setprecision(228) << fixed << l * u << "\n";
}

int32_t main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef _LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}