#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <iomanip>
#include <bitset>

using namespace std;

typedef long long ll;

const int N = 600001;
const long double e = 1e-15;
const ll INF = 1e12;

ll n, l;

struct Point {
    ll x = INF, y = INF;
    Point operator-(Point a) {
        Point c = *this;
        c.x -= a.x;
        c.y -= a.y;
        return c;
    }
    
} a[N], b[N];

bool cmp(Point a, Point b) {
    if (a.x * b.y - a.y * b.x == 0)
        return a.x * a.x + a.y * a.y < b.x * b.x + b.y * b.y;
    return a.x * b.y - a.y * b.x > 0;
}

vector < Point > ch;

void conv_hull() {
    Point o;
    for (int i = 0; i < n; ++i) {
        if (b[i].x < o.x) {
            o = b[i];
        }
        if (b[i].x == o.x && b[i].y < o.y) {
            o = b[i];
        }
    }
    for (int i = 0; i < n; ++i) {
        b[i] = b[i] - o;
    }
    sort(b, b + n, cmp);
    for (int i = 0; i < n; ++i) {
        if (ch.size() < 2) {
            ch.push_back(b[i]);
        }
        else {
            while (ch.size() >= 2 && cmp(b[i] - ch[ch.size() - 1], ch[ch.size() - 1] - ch[ch.size() - 2]))
                ch.pop_back();
            ch.push_back(b[i]);
        }
    }
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif

    cin >> n >> l;

    for (int i = 0; i < n; ++i) {
        cin >> a[i].x >> a[i].y;
    }

    for (int i = 0; i < n; ++i) {

        a[i].x -= l;
        b[i * 4] = a[i];
        a[i].x += l;

        a[i].x += l;
        b[i * 4 + 1] = a[i];
        a[i].x -= l;

        a[i].y -= l;
        b[i * 4 + 2] = a[i];
        a[i].y += l;

        a[i].y += l;
        b[i * 4 + 3] = a[i];
        a[i].y -= l;

    }

    n *= 4;

    conv_hull();

    long double ans = 0;

    for (int i = 0; i < ch.size(); ++i) {
        int j = (i + 1) % ch.size();
        ans += sqrtl((ch[i].x - ch[j].x) * (ch[i].x - ch[j].x) + (ch[i].y - ch[j].y) * (ch[i].y - ch[j].y));
    }

    cout << fixed << setprecision(12) << ans;

}