#pragma GCC target ("avx2")
#pragma GCC optimization ("O3")
#pragma GCC optimization ("unroll-loops")

#define _USE_MATH_DEFINES
#include<iostream>
#include<algorithm>
#include<tuple>
#include<vector>
#include<deque>
#include<queue>
#include<stack>
#include<string>
#include<map>
#include<unordered_map>
#include<set>
#include<unordered_set>
#include<iomanip>
#include<math.h>
#include<functional>
#include<list>
#include<bitset>

using namespace std;

struct pair_hash {
    template <class T1, class T2>
    size_t operator () (const pair<T1, T2>& p) const {
        auto h1 = std::hash<T1>{}(p.first);
        auto h2 = std::hash<T2>{}(p.second);
        return h1 ^ h2;
    }
};

vector<int> used;
unordered_set<pair<int, int>, pair_hash> used_edges;
vector<vector<int>> g;
vector<int> colors;
vector<pair<int, int>> edges;
int n;
int current_num = 1;

void dfs(int v, int cur) {
    used[v] -= 1;
    colors.push_back(v + 1);
    for (auto u : g[v]) {
        if (used[u] != 0 && used_edges.find({ min(u, v), max(u, v) }) != used_edges.end()) {
            edges.emplace_back(cur, ++current_num);
            used_edges.erase({ min(u, v), max(u, v) });
            dfs(u, current_num);
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m;
    cin >> n >> m;
    g.resize(n);
    edges.reserve(m);
    colors.reserve(m);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v; --u;
        used_edges.insert({ min(u, v), max(u, v) });
        g[v].push_back(u);
        g[u].push_back(v);
    }
    used.resize(n);
    for (int i = 0; i < n; ++i) {
        used[i] = g[i].size();
    }
    dfs(0, current_num);
    cout << colors.size() << '\n';
    for (auto i : colors)
        cout << i << ' ';
    cout << '\n';
    for (auto e : edges)
        cout << e.first << ' ' << e.second << '\n';
}