#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <climits>
#include <queue>
#include <string>
using namespace std;
typedef long long ll;

const int INF = INT_MAX;
int n, m;
vector<vector<int>> graph;
vector <int> dist;
vector <int> ways;
int ans;

void dfs(int v, int pred, int k) {
    if (dist[v] > 2) {
        return;
    }
    if (k == 3) {
        if (dist[v] == 1) {
            ans++;
        }
        return;
    }
    for (auto u: graph[v]) {
        if (u == pred) {
            continue;
        }
        dfs(u, v, k + 1);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    
    cin >> n >> m;
    graph.resize(n);
    dist.resize(n, -1);
    ways.resize(n);

    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        graph[a - 1].push_back(b - 1);
        graph[b - 1].push_back(a - 1);
    }

    queue <int> q;
    q.push(0);
    dist[0] = 0;
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto v: graph[u]) {
            if (dist[v] == -1) {
                dist[v] = dist[u] + 1;
                q.push(v);
            }
        }
    }
    
    dfs(0, -1, 0);

    cout << ans;

    return 0;
}